#!/usr/bin/perl
#recursive perl rename...roughly based on Robin Barker's (Robin.Barker@npl.co.uk)
#enhanced version of Larry Wall's original script eg/rename from the perl source
#
# This script is free software; you can redistribute it and/or modify it
#  under the same terms as Perl itself.
#
#2009-07-09 haui45@web.de

use strict;
use warnings;
use File::Find;
use File::Basename;
use Getopt::Long;
Getopt::Long::Configure('bundling');

 
 my ($rec, $verbose, $no_act, $force, $op, @files, $dir, @sorted) = 0;
 
 die "Usage: recrename [-v] [-n] [-f] [-r] perlexpr [path]\n" .
 		"Omitting the path argument is equivalent to:\n" .
		basename($0) . " -rn perlexpr .\n"
     unless GetOptions(
     'v|verbose' => \$verbose,
     'n|no-act'  => \$no_act,
     'f|force'   => \$force,
     'r|recursive'   => \$rec,
 ) and $op = shift;

 $verbose++ if $no_act;
if (@ARGV == 0){
	push @ARGV, ".";
	$rec = $no_act = 1;
}

 foreach $dir(@ARGV){
	 undef @files;
	 if($rec){
		 find (sub{push @files, $File::Find::name}, $dir);
		 @sorted = sort {grep(/\//, split "",$b) <=> grep(/\//, split "",$a)} @files;
		 pop @sorted if $sorted[-1] eq "."; 
	 }
	 else{
		 undef @sorted;
		 push @sorted, $dir;
	 }
	 foreach (@sorted){
		 my $was = $_;
		 $_ = basename $_;
		 eval $op;
		 die $@ if $@;
		 my $new = dirname($was) . "/" . $_;
		 if ($was eq $new) {
			 print "Skipping $was\n" if ($verbose == 2);
			 next;
		 }
		 if (-e $new and !$force) {
			 warn  "$was not renamed: $new already exists\n";
		 } elsif ($no_act or rename $was, $new) {
			 print "$was  ---renamed as---> $new\n" if $verbose;
		 } else {
			 warn  "Can't rename $was $new: $!\n";
		 }
	 }
 }
